searchNodes=[{"ref":"Solution.html","title":"Solution","type":"module","doc":"A Macro-based approach to working with ok/error tuples"},{"ref":"Solution.html#error/0","title":"Solution.error/0","type":"macro","doc":"Matches any error datatype. (See also is_error/1) Has to be used inside the LHS of a scase or swith statement."},{"ref":"Solution.html#error/1","title":"Solution.error/1","type":"macro","doc":"Matches {:error, res} (as well as tuples with more elements). res is then bound. (See also is_error/1) Has to be used inside the LHS of a scase or swith statement."},{"ref":"Solution.html#is_error/1","title":"Solution.is_error/1","type":"macro","doc":"Matches when x is one of the following: :error :undefined {:error, _} {:error, _, _} or a longer tuple where the first element is the atom :error iex&gt; is_error(:error) true iex&gt; is_error({:error, 42}) true iex&gt; is_error({:error, &quot;I&quot;, &quot;have&quot;, &quot;many&quot;, &quot;elements&quot;}) true iex&gt; is_error(:asdf) false iex&gt; is_error({:ok, &quot;success!&quot;}) iex&gt; is_error(:undefined) true"},{"ref":"Solution.html#is_error/2","title":"Solution.is_error/2","type":"macro","doc":"Matches when x is a long-enough ok-tuple that has more than n_elems elements."},{"ref":"Solution.html#is_ok/1","title":"Solution.is_ok/1","type":"macro","doc":"Matches when x is one of the following: :ok {:ok, _} {:ok, _, _} or a longer tuple where the first element is the atom :ok iex&gt; is_ok(:ok) true iex&gt; is_ok({:ok, 42}) true iex&gt; is_ok({:ok, &quot;I&quot;, &quot;have&quot;, &quot;many&quot;, &quot;elements&quot;}) true iex&gt; is_ok(:asdf) false iex&gt; is_ok({:error, &quot;failure&quot;}) false"},{"ref":"Solution.html#is_ok/2","title":"Solution.is_ok/2","type":"macro","doc":"Matches when x is a long-enough ok-tuple that has more than n_elems elements."},{"ref":"Solution.html#is_okerror/1","title":"Solution.is_okerror/1","type":"macro","doc":"Matches when either is_ok(x) or is_error(x) matches. iex&gt; is_okerror({:ok, &quot;Yay!&quot;}) true iex&gt; is_okerror({:error, &quot;Nay&quot;}) true iex&gt; is_okerror(false) false iex&gt; is_okerror(:undefined) true iex&gt; is_okerror({}) false iex&gt; is_okerror({:ok, &quot;the&quot;, &quot;quick&quot;, &quot;brown&quot;, &quot;fox&quot;}) true"},{"ref":"Solution.html#is_okerror/2","title":"Solution.is_okerror/2","type":"macro","doc":"Matches when x is a long-enough ok-tuple that has more than n_elems elements. Warning: Will not match plain :ok, :error or :undefined!"},{"ref":"Solution.html#ok/0","title":"Solution.ok/0","type":"macro","doc":"Matches any ok datatype. (See also is_ok/1) Has to be used inside the LHS of a scase or swith statement."},{"ref":"Solution.html#ok/1","title":"Solution.ok/1","type":"macro","doc":"Matches {:ok, res} (as well as tuples with more elements). res is then bound. (See also is_ok/1) Has to be used inside the LHS of a scase or swith statement."},{"ref":"Solution.html#okerror/0","title":"Solution.okerror/0","type":"macro","doc":"Matches any ok/error datatype. Has to be used inside the LHS of a scase or swith statement."},{"ref":"Solution.html#okerror/1","title":"Solution.okerror/1","type":"macro","doc":"Matches any ok or error type. tag is then boudn to :ok, :error or :undefined. (See also is_okerror/1) Has to be used inside the LHS of a scase or swith statement."},{"ref":"Solution.html#okerror/2","title":"Solution.okerror/2","type":"macro","doc":"Matches {:ok, res}, {:error, res} (as well as tuples with more elements). tag and res are bound. (See also is_okerror/1) tag is bound to the value :ok or :error depending on the tuple. res is bound to what the second element might be. Has to be used inside the LHS of a scase or swith statement."},{"ref":"Solution.html#scase/2","title":"Solution.scase/2","type":"macro","doc":"Works like a normal case-statement, but will expand ok(), error() and okerror()macros to the left side of -&gt;. iex&gt; scase {:ok, 10} do ...&gt; ok() -&gt; &quot;Yay!&quot; ...&gt; _ -&gt; &quot;Failure&quot; ...&gt; end &quot;Yay!&quot; You can also pass arguments to ok(), error() or okerror() which will then be bound and available to be used inside the case expression: iex&gt; scase {:ok, &quot;foo&quot;, 42} do ...&gt; ok(res, extra) -&gt; ...&gt; &quot;result: \#{res}, extra: \#{extra}&quot; ...&gt; _ -&gt; &quot;Failure&quot; ...&gt; end &quot;result: foo, extra: 42&quot; Note that for ok() and error(), the first argument will match the first element after the :ok or :error tag. On the other hand, for okerror(), the first argument will match the tag :ok or :error."},{"ref":"Solution.html#swith/2","title":"Solution.swith/2","type":"macro","doc":"Works like a normal with-statement, but will expand ok(), error() and okerror() macros to the left side of &lt;-. iex&gt; x = {:ok, 10} iex&gt; y = {:ok, 33} iex&gt; swith ok(res) &lt;- x, ...&gt; ok(res2) &lt;- y do ...&gt; &quot;We have: \#{res} \#{res2}&quot; ...&gt; else ...&gt; _ -&gt; &quot;Failure&quot; ...&gt; end &quot;We have: 10 33&quot; You can also pass arguments to ok(), error() or okerror() which will then be bound and available to be used inside the rest of the swith-expression: iex&gt; x = {:ok, 10} iex&gt; y = {:error, 33} iex&gt; z = {:ok, %{a: 42}} iex&gt; swith ok(res) &lt;- x, ...&gt; error(res2) &lt;- y, ...&gt; okerror(tag, metamap) &lt;- z, ...&gt; %{a: val} = metamap do ...&gt; &quot;We have: \#{res} \#{res2} \#{tag} \#{val}&quot; ...&gt; else ...&gt; _ -&gt; &quot;Failure&quot; ...&gt; end &quot;We have: 10 33 ok 42&quot; Note that for ok() and error(), the first argument will match the first element after the :ok or :error tag. On the other hand, for okerror(), the first argument will match the tag :ok or :error."}]